<?php

/**
 * inf_nov_kardex_hist actions.
 *
 * @package    nomina
 * @subpackage inf_nov_kardex_hist
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_nov_kardex_histActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.codtip, tab0.anho_mes, tab0.num_doc, tab0.estado desc' ;
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $anho_mes_ini = $request['anho_mes_ini'];
            $anho_mes_fin = $request['anho_mes_fin'];
            $periodo = $request['id_periodo'];
            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //whereTipoNovKa
            if (isset($request['id_tip_nov_ka'])) {
                $whereTipoNovKa = " AND tab0.id_tip_nov_ka = " . $request['id_tip_nov_ka'];
            } else {
                $whereTipoNovKa = ' ';
            }
            //estado
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            } else {
                $whereEstado = ' ';
            }
            //clase planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
             * Se cambia consulta para que solo muestre valor liq en estado = 1, yque sume el valor de ajuste del concepto de incapacidad - 20150227
             * Solo planilla tipo A - 20150728
             * Se cambia para que filtre periodo de la novedad y no de la liqnom - 20161021
             */
            $sql = <<<EOD
select count(*) as count from (

select

case when tab0.rn = 1 and tab0.estado = 1 then tab0.valor_liq + tab0.valor_ajuste 
when tab0.rn != 1 and tab0.estado = 1 then tab0.valor_liq 
else 0 end as valor_liq_per,
tab0.*

    from(

    select
    tab.codigo as codigo_clapla,
    tab.descripcion as descripcion_clapla,
    tab.id_clase_planta,
    tab1.*,
    tab2.codigo as codtip,
    tab2.descripcion as descripcion,
    tab2.codigo || ' - ' || tab2.descripcion as completo_tipka,
    tab3.nombre_apellido AS nombre_apellido,
    pernov.anho_mes,
    per.periodo,
    per.id_tipo_periodo,
    cpnka.id_concep_nomina,
    liqnom.num_dias as dias_liq,
    liqnom.valor_liquidado as valor_liq,
    maefon.codigo,
    maefon.razon_social,
    maefon.codigo || ' - ' || maefon.razon_social as eps_per,
    nvl(liqajus.valor_ajuste,0) as valor_ajuste,
    liqnom.rn

    from no_novedad_kardex tab1

    left join no_periodo_v pernov
    on pernov.id_periodo = tab1.id_periodo

    left join no_tip_nov_ka tab2
    on tab2.id_tip_nov_ka = tab1.id_tip_nov_ka

    left join no_datos_funcionario_v tab3
    on tab3.id_tipo_doc = tab1.id_tipo_doc
    and tab3.num_doc = tab1.num_doc

    left join (
             select
             clapla.codigo,
             clapla.descripcion,
             nom.*
              from no_nombramiento_v nom
    
              join no_clase_planta clapla
              on clapla.id_clase_planta = nom.id_clase_planta
    )tab
    on tab.id_tipo_doc = tab1.id_tipo_doc and tab.num_doc = tab1.num_doc
    
    left join no_concep_ka cpnka
    on cpnka.id_tip_nov_ka = tab1.id_tip_nov_ka

    left join (
        SELECT
         aut.*,
         ROW_NUMBER() OVER (
          partition by aut.id_periodo, aut.num_doc, aut.id_concep_nomina
          ORDER BY aut.id_liquida_nomina desc
         ) AS rn
        from no_liquida_nomina aut
    )liqnom
    on liqnom.id_concep_nomina = cpnka.id_concep_nomina
    --and liqnom.id_periodo = tab1.id_periodo
    and liqnom.id_tipo_doc = tab1.id_tipo_doc
    and liqnom.num_doc = tab1.num_doc
    and liqnom.fecha_desde = tab1.fecha_ini
    and liqnom.fecha_hasta = tab1.fecha_fin
/*
    left join no_liquida_nomina liqnom
    on liqnom.id_concep_nomina = cpnka.id_concep_nomina
    and liqnom.id_periodo = tab1.id_periodo
    and liqnom.id_tipo_doc = tab1.id_tipo_doc
    and liqnom.num_doc = tab1.num_doc
    and liqnom.fecha_desde = tab1.fecha_ini
    and liqnom.fecha_hasta = tab1.fecha_fin
*/
    

    left join no_periodo_v per
    on per.id_periodo = liqnom.id_periodo
                    
    left join no_liquida_aporte liqapo
    on liqapo.id_clase_fondo = 2
    and liqapo.id_periodo = tab1.id_periodo
    and liqapo.id_tipo_doc = tab1.id_tipo_doc
    and liqapo.num_doc = tab1.num_doc
    and liqapo.tipo_planilla = 'A'
    
    left join no_mae_fondos maefon
    on maefon.id_mae_fondos = liqapo.id_mae_fondos
    
    left join(
        select 
        ajus.id_tipo_doc,
        ajus.num_doc,
        ajus.id_concep_nomina,
        ajus.id_periodo,
        sum(ajus.num_dias) as num_dias,
        sum(ajus.valor_ajuste) as valor_ajuste
        from no_ajuste_nomina ajus
        group by
        ajus.id_tipo_doc,
        ajus.num_doc,
        ajus.id_concep_nomina,
        ajus.id_periodo
    )liqajus
    on liqnom.id_concep_nomina = liqajus.id_concep_nomina
    and tab1.id_periodo = liqajus.id_periodo
    and tab1.id_tipo_doc = liqajus.id_tipo_doc
    and tab1.num_doc = liqajus.num_doc

    )tab0

where tab0.anho_mes between $anho_mes_ini and $anho_mes_fin
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereEstado $whereTipoNovKa    
$whereClasePlanta    

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            /*
             * Se cambia consulta para que solo muestre valor liq en estado = 1, yque sume el valor de ajuste del concepto de incapacidad - 20150227
             * Se cambia periodo de la liquidacion y no de la novedad, y se deja que tome cualquier périodo de liquidacion, que se base por la fechas - 20160905
             * Se cambia para que filtre periodo de la novedad y no de la liqnom - 20161021
             */
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select

case when tab0.rn = 1 and tab0.estado = 1 then tab0.valor_liq + tab0.valor_ajuste 
when tab0.rn != 1 and tab0.estado = 1 then tab0.valor_liq 
else 0 end as valor_liq_per,
tab0.*

    from(

    select
    tab.codigo as codigo_clapla,
    tab.descripcion as descripcion_clapla,
    tab.id_clase_planta,
    tab1.*,
    tab2.codigo as codtip,
    tab2.descripcion as descripcion,
    tab2.codigo || ' - ' || tab2.descripcion as completo_tipka,
    tab3.nombre_apellido AS nombre_apellido,
    pernov.anho_mes,
    per.periodo,
    per.id_tipo_periodo,
    cpnka.id_concep_nomina,
    liqnom.num_dias as dias_liq,
    liqnom.valor_liquidado as valor_liq,
    maefon.codigo,
    maefon.razon_social,
    maefon.codigo || ' - ' || maefon.razon_social as eps_per,
    nvl(liqajus.valor_ajuste,0) as valor_ajuste,
    liqnom.rn

    from no_novedad_kardex tab1

    left join no_periodo_v pernov
    on pernov.id_periodo = tab1.id_periodo

    left join no_tip_nov_ka tab2
    on tab2.id_tip_nov_ka = tab1.id_tip_nov_ka

    left join no_datos_funcionario_v tab3
    on tab3.id_tipo_doc = tab1.id_tipo_doc
    and tab3.num_doc = tab1.num_doc

    left join (
             select
             clapla.codigo,
             clapla.descripcion,
             nom.*
              from no_nombramiento_v nom
    
              join no_clase_planta clapla
              on clapla.id_clase_planta = nom.id_clase_planta
    )tab
    on tab.id_tipo_doc = tab1.id_tipo_doc and tab.num_doc = tab1.num_doc
    
    left join no_concep_ka cpnka
    on cpnka.id_tip_nov_ka = tab1.id_tip_nov_ka

    left join (
        SELECT
         aut.*,
         ROW_NUMBER() OVER (
          partition by aut.id_periodo, aut.num_doc, aut.id_concep_nomina
          ORDER BY aut.id_liquida_nomina desc
         ) AS rn
        from no_liquida_nomina aut
    )liqnom
    on liqnom.id_concep_nomina = cpnka.id_concep_nomina
    --and liqnom.id_periodo = tab1.id_periodo
    and liqnom.id_tipo_doc = tab1.id_tipo_doc
    and liqnom.num_doc = tab1.num_doc
    and liqnom.fecha_desde = tab1.fecha_ini
    and liqnom.fecha_hasta = tab1.fecha_fin
/*
    left join no_liquida_nomina liqnom
    on liqnom.id_concep_nomina = cpnka.id_concep_nomina
    and liqnom.id_periodo = tab1.id_periodo
    and liqnom.id_tipo_doc = tab1.id_tipo_doc
    and liqnom.num_doc = tab1.num_doc
    and liqnom.fecha_desde = tab1.fecha_ini
    and liqnom.fecha_hasta = tab1.fecha_fin
*/
    

    left join no_periodo_v per
    on per.id_periodo = liqnom.id_periodo
                    
    left join no_liquida_aporte liqapo
    on liqapo.id_clase_fondo = 2
    and liqapo.id_periodo = tab1.id_periodo
    and liqapo.id_tipo_doc = tab1.id_tipo_doc
    and liqapo.num_doc = tab1.num_doc
    and liqapo.tipo_planilla = 'A'
    
    left join no_mae_fondos maefon
    on maefon.id_mae_fondos = liqapo.id_mae_fondos
    
    left join(
        select 
        ajus.id_tipo_doc,
        ajus.num_doc,
        ajus.id_concep_nomina,
        ajus.id_periodo,
        sum(ajus.num_dias) as num_dias,
        sum(ajus.valor_ajuste) as valor_ajuste
        from no_ajuste_nomina ajus
        group by
        ajus.id_tipo_doc,
        ajus.num_doc,
        ajus.id_concep_nomina,
        ajus.id_periodo
    )liqajus
    on liqnom.id_concep_nomina = liqajus.id_concep_nomina
    and tab1.id_periodo = liqajus.id_periodo
    and tab1.id_tipo_doc = liqajus.id_tipo_doc
    and tab1.num_doc = liqajus.num_doc

    )tab0

where tab0.anho_mes between $anho_mes_ini and $anho_mes_fin
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereEstado $whereTipoNovKa  
$whereClasePlanta

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_causa_vacac] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
